/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fidentis.analyst.feature.services;

import cz.fidentis.analyst.feature.FeaturePoint;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kubok
 */
public class FeaturePointsFpExporter {
    
        public FeaturePointsFpExporter() {
            
        }
    
        public void exportFeaturePointsToFP(List<FeaturePoint> featurePointList, String objectName) throws FileNotFoundException, IOException {
        File csvOutputFile = new File(String.format("%s_landmarks.fp", objectName));
        // CSV is a normal text file, need a writer
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(csvOutputFile))) {
            bw.write(String.format("<!--Saved by software Fidentis Analyst--><facialPoints model=\"%s\">", objectName));
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.newLine();
                    bw.write(String.format("<facialPoint type=\"%s\">", featurePoint.getFeaturePointType().getType()));
                    bw.newLine();
                    bw.write(String.format("<x>%f</x>", featurePoint.getX()));
                    bw.newLine();
                    bw.write(String.format("<y>%f</y>", featurePoint.getY()));
                    bw.newLine();
                    bw.write(String.format("<z>%f</z>", featurePoint.getZ()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
            bw.newLine();
            bw.write("</facialPoints>");
        }

    }
        
    //    public static void marshal() throws JAXBException, IOException {
    //        FeaturePointType fpt = new FeaturePointType(
    //                1,
    //                "Exocanthion R",
    //                "The point at the outer commissure of the eye where the outer margin of the upper eyelid meets the lower eyelid. If the precise spot cannot be found then the location is in the intersection of imaginary lines obtained by prolonging the eyelid margins. The point is bilateral.",
    //                "EX_R");
    //        FeaturePoint fp = new FeaturePoint(10, 20, 30, fpt);
    //
    //        JAXBContext context = JAXBContext.newInstance(FeaturePoint.class);
    //        Marshaller mar = context.createMarshaller();
    //        mar.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
    //        mar.marshal(fp, new File("./fp.xml"));
    //    }
    //
    //    public static FeaturePoint unmarshall() throws JAXBException, IOException {
    //        JAXBContext context = JAXBContext.newInstance(FeaturePoint.class);
    //        return (FeaturePoint) context.createUnmarshaller()
    //                .unmarshal(new FileReader("./fp.xml"));
    //    }
    //
    //    public static void main() throws JAXBException, IOException {
    //        marshal();
    //        unmarshall();
    //    }
        
}
